import { Metadata } from '../../Metadata.js';
export declare type ValueJSON = string | boolean | number;
export declare type LinkJSON = {
    nodeId: string;
    socket: string;
};
export declare type ParameterValueJSON = {
    value: ValueJSON;
};
export declare type ParameterLinkJSON = {
    link: LinkJSON;
};
export declare type ParameterJSON = ParameterValueJSON | ParameterLinkJSON;
export declare type ParametersJSON = {
    [key: string]: ParameterJSON;
};
export declare type FlowsJSON = {
    [key: string]: LinkJSON;
};
export declare type NodeJSON = {
    label?: string;
    type: string;
    id: string;
    parameters?: ParametersJSON;
    flows?: FlowsJSON;
    metadata?: Metadata;
};
export declare type VariableJSON = {
    label?: string;
    id: string;
    name: string;
    valueTypeName: string;
    initialValue: ValueJSON;
    metadata?: Metadata;
};
export declare type CustomEventJSON = {
    label?: string;
    id: string;
    name: string;
    metadata?: Metadata;
};
export declare type GraphJSON = {
    name?: string;
    nodes?: NodeJSON[];
    variables?: VariableJSON[];
    customEvents?: CustomEventJSON[];
    metadata?: Metadata;
};
//# sourceMappingURL=GraphJSON.d.ts.map