import { Metadata } from '../Metadata.js';
import { Socket } from '../Sockets/Socket.js';
import { NodeCategory } from './NodeCategory.js';
import { NodeEvalContext } from './NodeEvalContext.js';
export declare class Node {
    readonly category: NodeCategory;
    readonly typeName: string;
    readonly inputSockets: Socket[];
    readonly outputSockets: Socket[];
    readonly evalFunc: (context: NodeEvalContext) => void;
    id: string;
    label: string;
    metadata: Metadata;
    readonly flow: boolean;
    evaluateOnStartup: boolean;
    async: boolean;
    interruptibleAsync: boolean;
    constructor(category: NodeCategory, typeName: string, inputSockets: Socket[], outputSockets: Socket[], evalFunc: (context: NodeEvalContext) => void);
    getInputSocket(socketName: string): Socket;
    getOutputSocket(socketName: string): Socket;
}
//# sourceMappingURL=Node.d.ts.map