import { Node } from '../../../Nodes/Node.js';
import { Socket } from '../../../Sockets/Socket.js';
export class Sequence extends Node {
    constructor() {
        super('Flow', 'flow/sequence', [new Socket('flow', 'flow')], [
            new Socket('flow', '1'),
            new Socket('flow', '2'),
            new Socket('flow', '3')
        ], (context) => {
            const sequenceIteration = function sequenceIteration(i) {
                if (i < context.node.outputSockets.length) {
                    const outputSocket = context.node.outputSockets[i];
                    context.commit(outputSocket.name, () => {
                        sequenceIteration(i + 1);
                    });
                }
            };
            sequenceIteration(0);
        });
    }
}
//# sourceMappingURL=Sequence.js.map