import { Node } from '../../../Nodes/Node.js';
import { NodeEvalContext } from '../../../Nodes/NodeEvalContext.js';
import { Socket } from '../../../Sockets/Socket.js';

export class OnCustomEvent extends Node {
  constructor() {
    super(
      'Event',
      'event/customEvent',
      [new Socket('id', 'customEvent')],
      [new Socket('flow', 'flow')],
      (context: NodeEvalContext) => {
        const customEventId = context.readInput<string>('customEvent');
        const customEvent = context.getCustomEvent(customEventId);
        customEvent.eventEmitter.addListener(() => {
          context.commit('flow');
        });
      }
    );
    this.evaluateOnStartup = true;
    this.async = true;
    this.interruptibleAsync = true;
  }
}
